#include "common.h"
#include "ArchiverJACK.h"
#include "../util.h"
#include "../ConfigCode/config.h"
#include "../resource.h"


class CJackVolumeSizeDialog : public CDialogImpl<CJackVolumeSizeDialog>,public CWinDataExchange<CJackVolumeSizeDialog>
{
protected:
public:
	int VolumeSize;
	enum {IDD = IDD_DIALOG_JACK_SPECIFY_VOLUME_SIZE};

	// DDX}bv
	BEGIN_DDX_MAP(CJackVolumeSizeDialog)
		DDX_INT(IDC_EDIT_JACK_VOLUME_SIZE_AT_COMPRESS, VolumeSize)
	END_DDX_MAP()

	// bZ[W}bv
	BEGIN_MSG_MAP_EX(CJackVolumeSizeDialog)
		COMMAND_ID_HANDLER_EX(IDOK, OnOK)
		COMMAND_ID_HANDLER_EX(IDCANCEL, OnCancel)
	END_MSG_MAP()

	void OnOK(UINT uNotifyCode, int nID, HWND hWndCtl){
		if(!DoDataExchange(TRUE)){
			return;
		}
		if(VolumeSize<=0){
			::SetFocus(GetDlgItem(IDC_EDIT_JACK_VOLUME_SIZE_AT_COMPRESS));
			::SendMessage(GetDlgItem(IDC_EDIT_JACK_VOLUME_SIZE_AT_COMPRESS),EM_SETSEL,0,-1);
			ErrorMessage(CString(MAKEINTRESOURCE(IDS_ERROR_VALUE_MUST_BE_PLUS)));
			return;
		}
		EndDialog(nID);
	}

	void OnCancel(UINT uNotifyCode, int nID, HWND hWndCtl){
		EndDialog(nID);
	}
};


CArchiverJACK::CArchiverJACK()
{
//	TRACE(_T("CArchiverJACK()\n"));
	m_nRequiredVersion=20;
	m_strDllName=_T("Jack32.dll");
	m_AstrPrefix="Jack";
	m_LoadLevel=LOAD_DLL_MINIMUM;
}

CArchiverJACK::~CArchiverJACK()
{
//	TRACE(_T("~CArchiverJACK()\n"));
	FreeDLL();
}

bool CArchiverJACK::Compress(LPCTSTR ArcFileName,std::list<CString> &ParamList,CConfigManager &Config,const PARAMETER_TYPE Type,int Options,CString &strLog)
{
	if(!IsOK()){
		return false;
	}

	//ArcFileName͏o͐tH_
	ASSERT(0!=_tcslen(ArcFileName));
	TRACE(_T("ArcFileName=%s\n"),ArcFileName);

	//===========================
	// DLLɓnIvV̐ݒ
	//===========================
	TRACE(_T("DLLɓnIvV̐ݒ\n"));

	CString Param;//R}hC p[^ obt@

	Config.LoadConfig(CONFIG_JACK);
	Param+=_T("-r ");	//
	if(Options&COMPRESS_SFX){
		Param+=_T("-m1 ");	//SFX
	}
	else{
		Param+=_T("-m0 ");	//ʏ
	}
	if(Config.JACK.SpecifyVolumeSizeAtCompress){
		CJackVolumeSizeDialog vsd;
		if(IDOK!=vsd.DoModal()){
			return false;
		}
		CString Buf;
		Buf.Format(_T("-v:%d "),vsd.VolumeSize);
		Param+=Buf;//TCYw
	}
	else{
		CString Buf;
		Buf.Format(_T("-v:%d "),Config.JACK.VolumeSize);
		Param+=Buf;//TCYw
	}

	//Ώۃt@Cw
	Param+=_T("\"");
	Param+=*ParamList.begin();
	Param+=_T("\" ");

	//o̓tH_w
	Param+=_T("\"");
	Param+=ArcFileName;
	Param+=_T("\"");

	ASSERT(!Param.IsEmpty());
	TRACE(_T("ArchiveHandler Commandline Parameter:%s\n"),Param);

	TRACE(_T("ArchiveHandlerĂяo\n"));
	//char szLog[LOG_BUFFER_SIZE]={0};
	std::vector<char> szLog(LOG_BUFFER_SIZE);
	szLog[0]='\0';
	int Ret=ArchiveHandler(NULL,CT2A(Param),&szLog[0],LOG_BUFFER_SIZE-1);
	strLog=&szLog[0];

	return 0==Ret;
}

bool CArchiverJACK::Extract(LPCTSTR ArcFileName,CConfigManager &Config,bool bSafeArchive,LPCTSTR OutputDir,CString &strLog)
{
	if(!IsOK()){
		return false;
	}
	if(!bSafeArchive){
		//CString msg;
		//msg.Format(IDS_ERROR_DANGEROUS_ARCHIVE,ArcFileName);
		//ErrorMessage(msg);
		strLog.Format(IDS_ERROR_DANGEROUS_ARCHIVE,ArcFileName);
		return false;
	}

	//===========================
	// DLLɓnIvV̐ݒ
	//===========================
	TRACE(_T("DLLɓnIvV̐ݒ\n"));

	if(!Config.Common.Extract.ForceOverwrite){//㏑mF
		CString strFileName;

		//t@CǂŊi[t@C擾
		if(!GetContainedFileName(ArcFileName,strFileName)){
			//sȃt@C:CheckArchive()ŒeĂƊ҂ł
			return false;
		}

		//--------------
		// ݃`FbN
		//--------------
		strFileName.Insert(0,OutputDir);
		if(PathFileExists(strFileName)){
			CString msg;
			msg.Format(IDS_CONFIRM_OVERWRITE_MESSAGE_SIMPLE,strFileName);
			if(IDYES!=MessageBox(NULL,msg,CString(MAKEINTRESOURCE(IDS_MESSAGE_CAPTION)),MB_YESNO|MB_ICONQUESTION)){
				return false;
			}
		}
	}

	
	CString Param;//R}hC p[^ obt@

	//p[^
	Param+=_T("-c ");	//

	//A[JCut@Cw
	Param+=_T("\"");
	Param+=ArcFileName;
	Param+=_T("\" ");

	//o͐w
	Param+=_T("\"");
	Param+=OutputDir;
	Param+=_T("\"");

	ASSERT(!Param.IsEmpty());
	TRACE(_T("ArchiveHandler Commandline Parameter:%s\n"),Param);

	TRACE(_T("ArchiveHandlerĂяo\n"));
	//char szLog[LOG_BUFFER_SIZE]={0};
	std::vector<char> szLog(LOG_BUFFER_SIZE);
	szLog[0]='\0';
	int Ret=ArchiveHandler(NULL,CT2A(Param),&szLog[0],LOG_BUFFER_SIZE-1);
	strLog=&szLog[0];

	return 0==Ret;
}


bool CArchiverJACK::ExtractSpecifiedOnly(LPCTSTR ArcFileName,LPCTSTR OutputDir,std::list<CString>&,CString &,bool bUsePath)
{
	return false;
}

//=========================================================
// DTV̉\̂t@CǂڊmF
//=========================================================
bool CArchiverJACK::ExamineArchive(LPCTSTR ArcFileName,bool,bool &bInFolder,bool &bSafeArchive,CString &BaseDir)
{
	bInFolder=false;
	bSafeArchive=false;

	CString strFileName;

	//t@CǂŊi[t@C擾
	if(!GetContainedFileName(ArcFileName,strFileName))return false;
	if(-1==strFileName.FindOneOf(_T(":\\/"))){//pXw̕܂܂ĂȂ̂ňS
		bSafeArchive=true;
	}

/*
	̃R[hł͉𓀂t@CAt@CemFĂȂB
	ł肪ȂŔAJACK32.dll͓WJɏo̓t@C̈ѐ`FbNĂ͗lłB
	[]
	En-1Ԗڂ܂ł̃t@Cɂ͍׍HĂȂ
		EnԖڂ̃t@C׍HĂȂ
			𓀁An++
		EnԖڂ̃t@C׍HĂ
			En-1Ԗڂ܂ł̃t@CLhaForgeɗ^
				SƂĉ𓀂n߂̂́AJAK̓ꐫ`FbNɂ
			EnԖڂ̃t@CLhaForgeɗ^
				LhaForgeDTV`FbNɂ

	[ӓ_]
	݂̃R[hł́A㏑mF@\gƂAJAKt@CQǂނƂɂȂB
	߂ȂÃR[h𖳌āAExtract()ňSǂ`FbN悤ɂ΂悢B
	܂̂Ƃ́Aʂ̗ǂD悵ĂB
*/

	return true;
}

//wb_
// Original:JakTool.cpp/XacRett #49/(C)k.inaba
int CArchiverJACK::FindHeader(const BYTE* hdr,DWORD size)
{
	static const char Magic[]="This_Is_Jack_File";

	if(size<sizeof_JakHeader)
		return -1;

	if(0==strcmp((char*)hdr,Magic)){
		if(sizeof_JakHeader+((JakHeader*)hdr)->FileNameLen<size)
			return 0;
	}
	else if(hdr[0]=='M' && hdr[1]=='Z')	//ȉ
	{
		DWORD prev = 0xffffffff;
		for( DWORD i=0; i<size-sizeof_JakHeader; i++ )
		{
			if( hdr[i]!='T' )continue;
			if( hdr[i+1]!='h' )continue;
			if( hdr[(++i)+1]!='i' )continue;
			if( hdr[(++i)+1]!='s' )continue;
			if( hdr[(++i)+1]!='_' )continue;
			if( 0!=strcmp((char*)hdr+(++i)+1,Magic+5) )continue;

			// X^u̕Ɉ邱Ƃ̂ŁA
			// "This_Is_..."Ƃ͈Skip
			if( prev==0xffffffff )
				prev = (i-4);
			else
				return (i-4);
		}
		if(prev!=0xffffffff)
			return prev;
	}
	return -1;
}

bool CArchiverJACK::GetContainedFileName(LPCTSTR ArcFileName,CString &strFileName)
{
	strFileName.Empty();

	//t@Ceobt@
	std::vector<BYTE> Buffer;
	//t@CI[v
	HANDLE hFile=CreateFile(ArcFileName,GENERIC_READ,FILE_SHARE_READ,NULL,OPEN_EXISTING,FILE_ATTRIBUTE_NORMAL,NULL);
	if(INVALID_HANDLE_VALUE==hFile)return false;

	DWORD dwSize=GetFileSize(hFile,NULL);
		//4GB傫ȃt@CTCY͎擾łȂAIɂ͂̂悤ȑ傫ȃt@C͈Ȃ(JACK͕p)
	Buffer.resize(dwSize);

	DWORD dwRead=0;
	if(dwSize<0){
		CloseHandle(hFile);
		return false;
	}

	//ǂݎ
	ReadFile(hFile,&Buffer[0],dwSize,&dwRead,NULL);
	CloseHandle(hFile);

	//wb_
	int iPos=FindHeader(&Buffer[0],dwRead);
	if(-1==iPos){
		//Not Found
		return false;
	}

	JakHeader* lpHeader=(JakHeader*)&Buffer[iPos];

	for(unsigned int i=0;i<lpHeader->FileNameLen;i++){
		strFileName+=Buffer[iPos+sizeof_JakHeader+i];
	}
	return true;
}
