#include "common.h"
#include "ArchiverTAR.h"
#include "../util.h"
#include "../ConfigCode/config.h"
#include "../resource.h"

bool CArchiverTAR::bForceOverwrite=false;

CArchiverTAR::CArchiverTAR():
	ArchiverSetOwnerWindowEx(NULL),
	ArchiverKillOwnerWindowEx(NULL)
{
//	TRACE(_T("CArchiverTAR()\n"));
	m_dwInspectMode=0x00000002L;//M_REGARDLESS_INIT_FILE
	m_nRequiredVersion=230;
	m_strDllName=_T("TAR32.DLL");
	m_AstrPrefix="Tar";
}

CArchiverTAR::~CArchiverTAR()
{
//	TRACE(_T("~CArchiverTAR()\n"));
	FreeDLL();
}

LOAD_RESULT CArchiverTAR::LoadDLL(CConfigManager &Config,bool bSilent)
{
	FreeDLL();

	//NX̃\bhĂ
	LOAD_RESULT res=CArchiverDLL::LoadDLL(Config,bSilent);
	if(LOAD_RESULT_OK!=res){
		return res;
	}

	//㏑mFpR[obNݒ肷邽
	if(!ArchiverQueryFunctionList(33)){//33:TarSetOwnerWindowEx
		if(!bSilent){
			CString msg;
			msg.Format(IDS_ERROR_UNAVAILABLE_API,_T("TarSetOwnerWindowEx"));
			ErrorMessage(msg);
		}
		FreeDLL();
		return LOAD_RESULT_INVALID;
	}
	ArchiverSetOwnerWindowEx=(COMMON_ARCHIVER_SETOWNERWINDOWEX)GetProcAddress(m_hInstDLL,"TarSetOwnerWindowEx");
	if(NULL==ArchiverSetOwnerWindowEx){
		if(!bSilent){
			CString msg;
			msg.Format(IDS_ERROR_DLL_FUNCTION_GET,m_strDllName,_T("TarSetOwnerWindowEx"));
			ErrorMessage(msg);
		}
		FreeDLL();
		return LOAD_RESULT_INVALID;
	}

	if(!ArchiverQueryFunctionList(34)){//34:TarKillOwnerWindowEx
		if(!bSilent){
			CString msg;
			msg.Format(IDS_ERROR_UNAVAILABLE_API,_T("TarKillOwnerWindowEx"));
			ErrorMessage(msg);
		}
		FreeDLL();
		return LOAD_RESULT_INVALID;
	}
	ArchiverKillOwnerWindowEx=(COMMON_ARCHIVER_KILLOWNERWINDOWEX)GetProcAddress(m_hInstDLL,"TarKillOwnerWindowEx");
	if(NULL==ArchiverKillOwnerWindowEx){
		if(!bSilent){
			CString msg;
			msg.Format(IDS_ERROR_DLL_FUNCTION_GET,m_strDllName,_T("TarKillOwnerWindowEx"));
			ErrorMessage(msg);
		}
		FreeDLL();
		return LOAD_RESULT_INVALID;
	}
	return LOAD_RESULT_OK;
}

void CArchiverTAR::FreeDLL()
{
	if(m_hInstDLL){
		ArchiverSetOwnerWindowEx=NULL;
		ArchiverKillOwnerWindowEx=NULL;
		CArchiverDLL::FreeDLL();
	}
}

bool CArchiverTAR::Compress(LPCTSTR ArcFileName,std::list<CString> &ParamList,CConfigManager &Config,const PARAMETER_TYPE Type,int,CString &strLog)
{
	if(!IsOK()){
		return false;
	}

	ASSERT(0!=_tcslen(ArcFileName));
	TRACE(_T("ArcFileName=%s\n"),ArcFileName);

	//==============================================
	// X|Xt@Cpe|t@C擾
	//==============================================
	TCHAR ResponceFileName[_MAX_PATH+1];
	FILL_ZERO(ResponceFileName);
	if(!UtilGetTemporaryFileName(ResponceFileName,_T("tar"))){
		ErrorMessage(CString(MAKEINTRESOURCE(IDS_ERROR_TEMPORARY_FILE_CREATE)));
		return false;
	}
	ASSERT(0!=_tcslen(ResponceFileName));

	//==========================================
	// X|Xt@CɃA[JCu
	// kΏۃt@CL
	//==========================================
	{
		HANDLE hFile=CreateFile(ResponceFileName,GENERIC_WRITE,0,NULL,OPEN_EXISTING,FILE_ATTRIBUTE_NORMAL,NULL);
		if(INVALID_HANDLE_VALUE==hFile)
		{
			ErrorMessage(CString(MAKEINTRESOURCE(IDS_ERROR_TEMPORARY_FILE_ACCESS)));
			return false;
		}

		TRACE(_T("X|Xt@Cւ̏\n"));
		//kt@C
		WriteResponceFile(hFile,ArcFileName);
		//ȍ~̓IvVł͂Ȃ
		WriteResponceFile(hFile,_T("--"));

		std::list<CString>::iterator ite;
		for(ite=ParamList.begin();ite!=ParamList.end();ite++){
			WriteResponceFile(hFile,*ite);
		}
		CloseHandle(hFile);
	}

	//===========================
	// DLLɓnIvV̐ݒ
	//===========================
	TRACE(_T("DLLɓnIvV̐ݒ\n"));

	CString Param;//R}hC p[^ obt@

	Config.LoadConfig(CONFIG_TAR);
	switch(Type){
	case PARAMETER_TAR:
		Param+=_T("-cvf ");
		break;
	case PARAMETER_GZ:
		Param.Format(_T("-cvfGz%d "),Config.TAR.GzipCompressLevel);
		break;
	case PARAMETER_BZ2:
		Param.Format(_T("-cvfGB%d "),Config.TAR.Bzip2CompressLevel);
		break;
	case PARAMETER_TAR_GZ:
		Param.Format(_T("-cvfz%d "),Config.TAR.GzipCompressLevel);
		break;
	case PARAMETER_TAR_BZ2:
		Param.Format(_T("-cvfB%d "),Config.TAR.Bzip2CompressLevel);
		break;
	}

	//X|Xt@Cw
	Param+=_T("@\"");
	Param+=ResponceFileName;
	Param+=_T("\"");

	ASSERT(!Param.IsEmpty());
	TRACE(_T("ArchiveHandler Commandline Parameter:%s\n"),Param);

	TRACE(_T("ArchiveHandlerĂяo\n"));
	//char szLog[LOG_BUFFER_SIZE]={0};
	std::vector<char> szLog(LOG_BUFFER_SIZE);
	szLog[0]='\0';
	int Ret=ArchiveHandler(NULL,CT2A(Param),&szLog[0],LOG_BUFFER_SIZE-1);
	strLog=&szLog[0];

	//gX|Xt@C͏
	DeleteFile(ResponceFileName);

	return 0==Ret;
}

//bSafeArchive͖
bool CArchiverTAR::Extract(LPCTSTR ArcFileName,CConfigManager &Config,bool,LPCTSTR OutputDir,CString &strLog)
{
	if(!IsOK()){
		return false;
	}
	//㏑֌W̓Zbg
	bForceOverwrite=false;

	//===========================
	// DLLɓnIvV̐ݒ
	//===========================
	TRACE(_T("DLLɓnIvV̐ݒ\n"));

	CString Param;//R}hC p[^ obt@

	//𓀃p[^
	Param+=_T("-xvf ");			//

	//㏑ǂ
	bForceOverwrite=(FALSE!=Config.Common.Extract.ForceOverwrite);

	//R[obNݒ
	ArchiverSetOwnerWindowEx(NULL,ArchiverProc);

	//A[JCut@Cw
	Param+=_T("\"");
	Param+=ArcFileName;
	Param+=_T("\" ");

	//o͐w
	Param+=_T("\"");
	Param+=OutputDir;
	Param+=_T("\"");

	ASSERT(!Param.IsEmpty());
	TRACE(_T("ArchiveHandler Commandline Parameter:%s\n"),Param);

	TRACE(_T("ArchiveHandlerĂяo\n"));
	//char szLog[LOG_BUFFER_SIZE]={0};
	std::vector<char> szLog(LOG_BUFFER_SIZE);
	szLog[0]='\0';
	int Ret=ArchiveHandler(NULL,CT2A(Param),&szLog[0],LOG_BUFFER_SIZE-1);
	strLog=&szLog[0];

	ArchiverKillOwnerWindowEx(NULL);

	return 0==Ret;
}

/*//X|Xt@CɃt@CށB
//Lȃt@CnhNULLłȂt@CnƁB
void CArchiverTAR::WriteResponceFile(HANDLE hFile,LPCTSTR fname)
{
	TCHAR Buffer[_MAX_PATH+3];
	FILL_ZERO(Buffer);

	//t@C̐擪'-'Ȃ.\(t@C)Ƃ
	if(_MBC_SINGLE==_mbsbtype((const unsigned char*)fname,0)&&_T('-')==fname[0]){
		_sntprintf_s(Buffer,_MAX_PATH+2,_T(".\\%s"),fname);
	}
	else{
		_tcsncpy_s(Buffer,fname,_MAX_PATH);
	}
/*	PathQuoteSpaces(Buffer);

	TRACE(Buffer);
	TRACE(_T("\n"));

	DWORD dwWritten=0;
	//t@Co
	WriteFile(hFile,Buffer,(DWORD)_tcslen(Buffer)*sizeof(TCHAR),&dwWritten,NULL);

	//t@C؂邽߂̉s
	TCHAR CRLF[]=_T("\r\n");
	WriteFile(hFile,&CRLF,(DWORD)_tcslen(CRLF)*sizeof(TCHAR),&dwWritten,NULL);* /
	CArchiverDLL::WriteResponceFile(hFile,Buffer);
}*/


//=========================================================
// TarGetFileName()̏o͌ʂɁAi[ꂽt@CpX
// Ă邩ǂʂAdtH_쐬h
//=========================================================
bool CArchiverTAR::ExamineArchive(LPCTSTR ArcFileName,bool bSkipDir,bool &bInFolder,bool &,CString &BaseDir)
{
	if(bSkipDir){
		TRACE(_T("dtH_\n"));
		return true;
	}
	return _ExamineArchiveFast(ArcFileName,bInFolder,BaseDir);
}


BOOL CArchiverTAR::ArchiverProc(HWND _hwnd, UINT _uMsg, UINT _nState, LPVOID _lpEis)
{
	//TRUEԂ΃LZƂȂ
	if(0!=_nState)return FALSE;
	if(bForceOverwrite)return FALSE;

	LPEXTRACTINGINFO ExtractInfo=(LPEXTRACTINGINFO)_lpEis;
	CString DestFileName=ExtractInfo->szDestFileName;	//o͐t@C
	DestFileName.Replace(_T('/'),_T('\\'));	//pX̋؂𓝈
//	TRACE(_T("--------ArchiverProc\n"));
//	TRACE(_T("DestFileName=%s\n"),DestFileName);
//	TRACE(_T("FileSize    =%d\n"),ExtractInfo->dwFileSize);
//	TRACE(_T("SrcFileName =%s\n"),ExtractInfo->szSourceFileName);

	if(PathIsDirectory(DestFileName))return FALSE;	//fBNg݂͖̏
	if(!PathFileExists(DestFileName))return FALSE;	//݂Ȃt@C͂̂܂܉

//	TRACE(_T("This is Existing File.\n"));
	//--------------------------
	// ݐt@C̒
	//--------------------------
	HANDLE hFile=CreateFile(DestFileName,GENERIC_READ,FILE_SHARE_READ,NULL,OPEN_EXISTING,FILE_ATTRIBUTE_NORMAL,NULL);
	if(INVALID_HANDLE_VALUE==hFile)
	{
		CString msg;
		msg.Format(IDS_ERROR_GET_FILE_INFO,DestFileName);
		ErrorMessage(msg);
		return TRUE;
	}
	DWORD FileSizeHigh;
	DWORD FileSizeLow=GetFileSize(hFile,&FileSizeHigh);	//t@CTCY擾

	ULARGE_INTEGER FileSize;
	FileSize.LowPart = FileSizeLow;
	FileSize.HighPart = FileSizeHigh;

	FILETIME ft;
	GetFileTime(hFile,NULL,NULL,&ft);	//XV擾
	CloseHandle(hFile);

	//㏑mF_CAO
	CConfirmOverwriteDialog CORDlg;

	CORDlg.DiskFileName=DestFileName;
	CORDlg.DiskFileSize=FileSize;
	CORDlg.DiskFileTime=ft;

	CORDlg.ExtractFileSize=ExtractInfo->dwFileSize;

	switch(CORDlg.DoModal()){
	case IDC_BUTTON_EXTRACT_CONTINUE:
		return FALSE;
	case IDC_BUTTON_EXTRACT_OVERWRITE_ALL:
		bForceOverwrite=true;
		return FALSE;
	case IDC_BUTTON_EXTRACT_ABORT:
		TRACE(_T("Extraction Aborted.\n"));
		return TRUE;
	}
	return FALSE;
}

//========================================================
LRESULT CConfirmOverwriteDialog::OnInitDialog(HWND hWnd, LPARAM lParam)
{
	CenterWindow();
	Edit_MessageArea=GetDlgItem(IDC_EDIT_CONFIRM_OVERWRITE_MESSAGE);

	FILETIME LocalFileTime;
	SYSTEMTIME DiskFileSystemTime;

	FileTimeToLocalFileTime(&DiskFileTime,&LocalFileTime);
	FileTimeToSystemTime(&LocalFileTime,&DiskFileSystemTime);

	CString msg;
	msg.Format(IDS_CONFIRM_OVERWRITE_MESSAGE,
		DiskFileName,
		DiskFileSystemTime.wYear,DiskFileSystemTime.wMonth,
		DiskFileSystemTime.wDay,DiskFileSystemTime.wHour,
		DiskFileSystemTime.wMinute,DiskFileSystemTime.wSecond,
		DiskFileSize,
		ExtractFileSize);
	Edit_MessageArea.SetWindowText(msg);
	return TRUE;
}

void CArchiverTAR::PreExtractSpecifiedOnly()
{
	//㏑mF
	bForceOverwrite=false;
}

bool CArchiverTAR::ExtractSpecifiedOnly(LPCTSTR ArcFileName,LPCTSTR OutputDir,std::list<CString> &FileList,CString &strLog,bool bUsePath)
{
	if(!IsOK()){
		return false;
	}

	//==============================================
	// X|Xt@Cpe|t@C擾
	//==============================================
	TCHAR ResponceFileName[_MAX_PATH+1];
	FILL_ZERO(ResponceFileName);
	if(!UtilGetTemporaryFileName(ResponceFileName,_T("tar"))){
		ErrorMessage(CString(MAKEINTRESOURCE(IDS_ERROR_TEMPORARY_FILE_CREATE)));
		return false;
	}
	ASSERT(0!=_tcslen(ResponceFileName));

	//𓀑Ώۃt@CX|Xt@Cɏo
	{
		HANDLE hFile=CreateFile(ResponceFileName,GENERIC_WRITE,0,NULL,OPEN_EXISTING,FILE_ATTRIBUTE_NORMAL,NULL);
		if(INVALID_HANDLE_VALUE==hFile)
		{
			ErrorMessage(CString(MAKEINTRESOURCE(IDS_ERROR_TEMPORARY_FILE_ACCESS)));
			return false;
		}

		std::list<CString>::iterator ite=FileList.begin();
		const std::list<CString>::iterator end=FileList.end();
		for(;ite!=end;ite++){
			WriteResponceFile(hFile,*ite);
		}
		CloseHandle(hFile);
	}

	//===========================
	// DLLɓnIvV̐ݒ
	//===========================
	CString Param;

	//𓀃p[^
	Param+=_T("-xv ");			//
	if(!bUsePath)Param+=_T("--use-directory=0 ");	//pX񖳌

	//A[JCut@Cw
	Param+=_T("\"");
	Param+=ArcFileName;
	Param+=_T("\" ");

	//o͐tH_
	Param+=_T("\"");
	Param+=OutputDir;
	Param+=_T("\" ");

	//X|Xt@Cw
	Param+=_T("-- @\"");
	Param+=ResponceFileName;
	Param+=_T("\"");

	//R[obNݒ
	ArchiverSetOwnerWindowEx(NULL,ArchiverProc);

	TRACE(_T("ArchiveHandlerĂяo\nCommandline Parameter:%s\n"),Param);
	//char szLog[LOG_BUFFER_SIZE]={0};
	std::vector<char> szLog(LOG_BUFFER_SIZE);
	szLog[0]='\0';
	int Ret=ArchiveHandler(NULL,CT2A(Param),&szLog[0],LOG_BUFFER_SIZE-1);
	strLog=&szLog[0];

	ArchiverKillOwnerWindowEx(NULL);
	//gX|Xt@C͏
	DeleteFile(ResponceFileName);

	return 0==Ret;
}

