#include "common.h"
#include "shellmanager.h"
#ifdef __UNINSTALLER__
 #include "../uninstall/resource.h"
#elif defined(__LFASSIST__)
 #include "../LFAssist/resource.h"
#else
 #include "../resource.h"
#endif


const int CLSID_STRING_SIZE=(39 + 1);

// {713B479F-6F2B-48e9-B545-5591CCFE398F}
static const GUID CLSID_ShellExt = 
{ 0x713b479f, 0x6f2b, 0x48e9, { 0xb5, 0x45, 0x55, 0x91, 0xcc, 0xfe, 0x39, 0x8f } };


//-------------------------------------------------------------------------
// ShellRegisterServer			gVFo^
//-------------------------------------------------------------------------
bool ShellRegisterServer(HWND hWnd,LPCTSTR inDllPath)
{
	// Cu[h
	HINSTANCE theDllH = ::LoadLibrary(inDllPath);
	if(!theDllH){
		// [ho܂ł
		CString msg;
		msg.Format(IDS_ERROR_DLL_LOAD,inDllPath);
		MessageBox(hWnd,msg,CString(MAKEINTRESOURCE(IDS_MESSAGE_CAPTION)),MB_OK|MB_ICONSTOP);
		return false;
	}

	// Gg[|CgTĎs
	FARPROC lpDllEntryPoint;
	(FARPROC&)lpDllEntryPoint = ::GetProcAddress(theDllH,"DllRegisterServer");
	if(lpDllEntryPoint){
		// o^
		(*lpDllEntryPoint)();
//		MessageBeep(MB_OK);
	}else{
		// DllRegisterServer ܂
		CString msg;
		msg.Format(IDS_ERROR_DLL_FUNCTION_GET,inDllPath,_T("DllRegisterServer"));
		MessageBox(hWnd,msg,CString(MAKEINTRESOURCE(IDS_MESSAGE_CAPTION)),MB_OK|MB_ICONSTOP);
		::FreeLibrary(theDllH);
		return false;
	}
	::FreeLibrary(theDllH);
	return true;
}

//-------------------------------------------------------------------------
// ShellUnregisterServer			gVF
//-------------------------------------------------------------------------
bool ShellUnregisterServer(HWND hWnd,LPCTSTR inDllPath)
{
	// Cu[h
	HINSTANCE theDllH = ::LoadLibrary(inDllPath);
	if(!theDllH){
		// ۰ޏo܂ł
		CString msg;
		msg.Format(IDS_ERROR_DLL_LOAD,inDllPath);
		MessageBox(hWnd,msg,CString(MAKEINTRESOURCE(IDS_MESSAGE_CAPTION)),MB_OK|MB_ICONSTOP);
		return false;
	}

	// Gg[|CgTĎs
	FARPROC	lpDllEntryPoint;
	(FARPROC&)lpDllEntryPoint = ::GetProcAddress(theDllH,"DllUnregisterServer");
	if(lpDllEntryPoint){
		// o^
		(*lpDllEntryPoint)();
//		MessageBeep(MB_OK);
	}else{
		// DllUnregisterServer ܂
		CString msg;
		msg.Format(IDS_ERROR_DLL_FUNCTION_GET,inDllPath,_T("DllUnregisterServer"));
		MessageBox(hWnd,msg,CString(MAKEINTRESOURCE(IDS_MESSAGE_CAPTION)),MB_OK|MB_ICONSTOP);
		::FreeLibrary(theDllH);
		return false;
	}
	::FreeLibrary(theDllH);
	return true;
}


/*-------------------------------------------------------------------------*/
// CLSIDtoSTRING			NXID𕶎ɕϊ
/*-------------------------------------------------------------------------*/
void CLSIDtoSTRING(REFCLSID inClsid,CString &outCLSID)
{
	WCHAR theCLSID[CLSID_STRING_SIZE];

	// NXID𕶎ɕϊB
	StringFromGUID2(inClsid, theCLSID,CLSID_STRING_SIZE);
	outCLSID=theCLSID;
}

//-------------------------------------------------------------------------
// ShellRegistCheck		gShellݓo^Ă邩`FbN
//-------------------------------------------------------------------------
bool ShellRegistCheck()
{
	const GUID inGUID=CLSID_ShellExt;
	bool Result=false;
	// NXIDAWXgL[쐬
	CString theCLSID;
	CLSIDtoSTRING(inGUID, theCLSID);

	// L[쐬
	CString theKey=_T("CLSID\\")+theCLSID;

	// WXgɃL[邩ǂT

	// wL[̃I[v
	HKEY theKeyChildH;
	LONG theRes = ::RegOpenKeyEx(HKEY_CLASSES_ROOT, theKey, 0, /*KEY_ALL_ACCESS*/KEY_READ, &theKeyChildH);
	if(theRes != ERROR_SUCCESS)return Result;
	//wL[ɕ֘AÂĂΑ`FbN˔j
	DWORD dwLength=0;
	::RegQueryValueEx(theKeyChildH, NULL, NULL, NULL, NULL,&dwLength);
	if(dwLength>1){
		//`FbN
		// qGg̗
		TCHAR		theBuffer[256];
		DWORD		theSize = 256;
		FILETIME	theTime;
		DWORD		theIdx = 0;
		while(S_OK==::RegEnumKeyEx(theKeyChildH, theIdx, theBuffer, &theSize, NULL, NULL, NULL, &theTime)){
			if(_tcscmp(theBuffer,_T("InprocServer32")) == 0){
				// rSI
				Result = true;
				break;
			}
			theSize = 256;
			theIdx++;
		}
	}

	// Close the child.
	::RegCloseKey(theKeyChildH);

	return Result;
}

