#include "common.h"
#include "ExtractEx.h"
#include "../resource.h"
#include "../util.h"
#include "../Components/TemporaryDirMgr.h"

//Base:fBNg
bool ExtractEx(CArchiverDLL *lpArchiver,LPCTSTR ArcFileName,CDirectoryTree *Base,std::list<CDirectoryTree*>& ItemList,LPCTSTR lpszOutputBaseDir,bool bCollapseDir,CString &strLog)
{
	ASSERT(lpArchiver);
	if(!lpArchiver){
		return false;
	}

	//---UNICODE֌W̃`FbN
	if(!lpArchiver->IsUnicodeCapable()&&!UtilCheckT2A(lpszOutputBaseDir)){
		//UNICODEɑΉĂȂ̂UNICODEt@C̃tH_ɓWJ悤Ƃ
		strLog=CString(MAKEINTRESOURCE(IDS_ERROR_UNICODEPATH));
		return false;
	}

	//------------------------------------
	// A[JCȗ݂͊Ƀ`FbNς
	//------------------------------------

	//---Xgt@CƃfBNg𕪗
	CDirectoryTree *lpFileParent=NULL;	//t@C̐e
	std::list<CString> FileList;	//t@Cp
	std::list<CDirectoryTree*> DirectoryList;	//fBNgp

	{
		std::list<CDirectoryTree*>::iterator ite=ItemList.begin();
		const std::list<CDirectoryTree*>::iterator end=ItemList.end();
		for(;ite!=end;ite++){
			CDirectoryTree* dt=*ite;
			ASSERT(dt);
			if(!dt)continue;

			if(dt->IsDirectory()){
				DirectoryList.push_back(dt);
			}
			else{
				lpFileParent=dt->GetParent();
				FileList.push_back(dt->GetFullPath());
			}
		}
	}
	ASSERT((!FileList.empty())||(!DirectoryList.empty()));

	//----------------
	// t@C
	//----------------
	if(!FileList.empty()){
		CString strOutputDir;
		if(!bCollapseDir)CDirectoryTree::GetDirPathRelative(lpFileParent,Base,strOutputDir);
		strOutputDir.Insert(0,lpszOutputBaseDir);
		//CString strLog;
		bool bRet=lpArchiver->ExtractSpecifiedOnly(ArcFileName,strOutputDir,FileList,strLog);
		if(!bRet){
/*			CLogDialog LogDlg;
			LogDlg.SetData(strLog);
			LogDlg.DoModal();*/
			return false;
		}
	}

	//--------------------
	// fBNg
	//--------------------
	if(!DirectoryList.empty()){
		std::list<CDirectoryTree*>::iterator ite=DirectoryList.begin();
		const std::list<CDirectoryTree*>::iterator end=DirectoryList.end();
		if(lpArchiver->QueryFastExtractSpecifiedOnlySupported()){	//łgp\
			for(;ite!=end;ite++){
				if(!ExtractSubDirectoryFast(lpArchiver,ArcFileName,bCollapseDir?(*ite)->GetParent():Base,*ite,lpszOutputBaseDir,strLog))return false;
			}
		}else{
			for(;ite!=end;ite++){
				if(!ExtractSubDirectory(lpArchiver,ArcFileName,bCollapseDir?(*ite)->GetParent():Base,*ite,lpszOutputBaseDir,strLog))return false;
			}
		}
	}
	return true;
}

bool ExtractSubDirectory(CArchiverDLL *lpArchiver,LPCTSTR ArcFileName,CDirectoryTree *Base,CDirectoryTree* Dir,LPCTSTR lpszOutputBaseDir,CString &strLog)
{
	ASSERT(lpArchiver);
	ASSERT(Dir);
	ASSERT(Dir->IsDirectory());
	if(!lpArchiver||!Dir){
		return false;
	}
	//------------------------------------
	// A[JCȗ݂͊Ƀ`FbNς
	//------------------------------------

	//fBNgƂŕKv邩ǂ
	bool bRestoreEmptyDirectory=false;

	//fBNg̃t@C
	std::list<CString> FileList;	//t@Cp
	std::list<CDirectoryTree*> DirectoryList;	//fBNgp

	{
		//fBNgA[JCuɃGgƂēo^ĂȂo͂
		//->L:o͐ƌ
//		if(_tcslen(Dir->GetFullName())>0){
//			FileList.push_back(Dir->GetFullName());
//		}
		std::vector<CDirectoryTree*>::iterator ite=Dir->GetIterator(true);
		const std::vector<CDirectoryTree*>::iterator end=Dir->GetIterator(false);
		for(;ite!=end;ite++){
			CDirectoryTree* dt=*ite;

			ASSERT(dt);
			if(!dt)continue;

			if(dt->IsDirectory()){
				DirectoryList.push_back(dt);
			}
			else{
				FileList.push_back(dt->GetFullPath());
			}
		}
		if(FileList.empty()&&DirectoryList.empty()){
			//tH_ꍇ
			if(_tcslen(Dir->GetFullPath())<=0){
				//tpXȂ:A[JCuɂ݂͑ȂtH_
				TRACE(_T("Nothing to Extract\n"));
				return true;
			}
			else{
				bRestoreEmptyDirectory=true;
			}
		}
		else{
			bRestoreEmptyDirectory=false;
		}
	}

	//--------------------------------------
	// Cꂽo̓fBNgpXZo
	//--------------------------------------
	CString strOutputDir;
	CDirectoryTree::GetDirPathRelative(Dir,Base,strOutputDir);

	//o̓fBNgƌ
	strOutputDir.Insert(0,lpszOutputBaseDir);

	if(strOutputDir.GetLength()>_MAX_PATH){
		//tH_Ȃ肷
		//ErrorMessage(CString(MAKEINTRESOURCE(IDS_ERROR_MAX_PATH)));
		strLog=CString(MAKEINTRESOURCE(IDS_ERROR_MAX_PATH));
		return false;
	}
	//----------------------------
	// fBNgGg̍Č
	//----------------------------
	TRACE(_T("OutputDir=%s\n"),strOutputDir);
	if(bRestoreEmptyDirectory){
		//fBNgGgƂŕKv
		//fBNg쐬
		TRACE(_T("Created by MakeSureDirectoryPathExists()\n"));
		if(!UtilMakeSureDirectoryPathExists(strOutputDir)){
/*			CString msg;
			msg.Format(IDS_ERROR_CANNOT_MAKE_DIR,strOutputDir);
			ErrorMessage(msg);*/
			strLog.Format(IDS_ERROR_CANNOT_MAKE_DIR,strOutputDir);
			return false;
		}
	}

	//---ċAIɏ

	//----------------
	// t@C
	//----------------
	if(!FileList.empty()){
		//CString strLog;
		if(!lpArchiver->ExtractSpecifiedOnly(ArcFileName,strOutputDir,FileList,strLog)){
			/*CLogDialog LogDlg;
			LogDlg.SetData(strLog);
			LogDlg.DoModal();*/
			return false;
		}
	}

	//--------------------
	// fBNg
	//--------------------
	if(!DirectoryList.empty()){
		std::list<CDirectoryTree*>::iterator ite=DirectoryList.begin();
		const std::list<CDirectoryTree*>::iterator end=DirectoryList.end();
		for(;ite!=end;ite++){
			if(!ExtractSubDirectory(lpArchiver,ArcFileName,Base,*ite,lpszOutputBaseDir,strLog))return false;
		}
	}
	return true;
}

//̌`݂̂ŃT|[g鍂Ȏ@:ZIP/7z̍}
//7-zip32.dllȊOł͌؂ĂȂ(DLLԂł܂ɂdl̈Ⴂ̂ŃT|[g߂)
bool ExtractSubDirectoryFast(CArchiverDLL *lpArchiver,LPCTSTR ArcFileName,CDirectoryTree *Base,CDirectoryTree* Dir,LPCTSTR lpszOutputBaseDir,CString &strLog)
{
	ASSERT(lpArchiver);
	ASSERT(Dir);
	ASSERT(Dir->IsDirectory());
	if(!lpArchiver||!Dir){
		return false;
	}
	//------------------------------------
	// A[JCȗ݂͊Ƀ`FbNς
	//------------------------------------

	bool bRestoreDir=false;	//fBNgƂŕKvtrue
	std::list<CString> FileList;
	if(_tcslen(Dir->GetFullPath())>0){
		//fBNgA[JCuɃGgƂēo^ĂȂo͂
		CString tmpPath(Dir->GetFullPath());
		if(tmpPath[tmpPath.GetLength()-1]==_T('\\')||tmpPath[tmpPath.GetLength()-1]==_T('/')){
			//\/폜
			tmpPath.Delete(tmpPath.GetLength()-1);
		}
		FileList.push_back(tmpPath);
	}else{
		//fBNgo^ĂȂ̂ŃpXZo
		std::vector<CDirectoryTree*>::iterator ite=Dir->GetIterator(true);
		const std::vector<CDirectoryTree*>::iterator end=Dir->GetIterator(false);
		if(ite!=end){
			bRestoreDir=true;
			CPath tmpPath((*ite)->GetFullPath());
			BOOL bReplace=((CString)tmpPath).Replace(_T('/'),_T('\\'));	//\/ɒuKvtrue
			tmpPath.RemoveBackslash();	//fBNg症ɂ
			tmpPath.RemoveFileSpec();	//efBNg܂Ő؂߂
			tmpPath.Append(_T("*"));	//fBNgȉ̑SẴt@CWJ
			FileList.push_back(tmpPath);
		}else{	//͂Ȃ͂;fBNgo^AfBNg̃t@CȂȂAfBNg݂͑Ȃ
			ASSERT(!"Unexepected pattern");
		}
	}

	//--------------------------------------
	// Cꂽo̓fBNgpXZo
	//--------------------------------------
	//---{̏o͐
	CString strOutputDir;
	CDirectoryTree::GetDirPathRelative(Dir,Base,strOutputDir);
	//o̓fBNgƌ
	strOutputDir=lpszOutputBaseDir+strOutputDir;
	if(strOutputDir.GetLength()>_MAX_PATH){
		//tH_Ȃ肷
		strLog=CString(MAKEINTRESOURCE(IDS_ERROR_MAX_PATH));
		return false;
	}

	//FileListɂ͂PĂȂ͂
	ASSERT(FileList.size()==1);

	//ꎞtH_
	CTemporaryDirectoryManager tdm(_T("lhaf"));
	CPath strTempOutput(tdm.GetDirPath());
	if(bRestoreDir){	//fBNgƂŕ
		strTempOutput+=*FileList.begin();
		strTempOutput.AddBackslash();
		TRACE(_T("Ƃł̃fBNg:%s\n"),(LPCTSTR)strTempOutput);
		if(!UtilMakeSureDirectoryPathExists(strTempOutput)){
			strLog.Format(IDS_ERROR_CANNOT_MAKE_DIR,strTempOutput);
			return false;
		}
	}
	//---ꎞtH_ɂ܂Ƃ߂ēWJAォtH_\؂o
	// t@CWJ
	if(!FileList.empty()){
		if(!lpArchiver->ExtractSpecifiedOnly(ArcFileName,strTempOutput,FileList,strLog,true/*bUsePath*/)){
			return false;
		}
	}

	//葤t@Cw
	CString strOrgPath;
	CDirectoryTree::GetDirPathRelative(Dir,NULL,strOrgPath);	//𓀐̃pX擾
	CPath tmp(strTempOutput);
	tmp+=(LPCTSTR)strOrgPath;	//PathAppend
	tmp.RemoveBackslash();
	CString strSrcFiles(tmp);
	strSrcFiles+=_T("||");
	//󂯑t@Cw
	tmp=(LPCTSTR)strOutputDir;
	tmp.RemoveBackslash();
	CString strDestFiles(tmp);
	strDestFiles+=_T("||");

	//'|''\0'ɕϊ
	std::vector<TCHAR> srcBuf(strSrcFiles.GetLength()+1);
	UtilMakeFilterString(strSrcFiles,&srcBuf[0],srcBuf.size());
	std::vector<TCHAR> destBuf(strDestFiles.GetLength()+1);
	UtilMakeFilterString(strDestFiles,&destBuf[0],destBuf.size());

	//t@Ce
	SHFILEOPSTRUCT fileOp={0};
	fileOp.wFunc=FO_MOVE;
	fileOp.fFlags=FOF_MULTIDESTFILES|/*FOF_NOCONFIRMATION|*/FOF_NOCONFIRMMKDIR|FOF_NOCOPYSECURITYATTRIBS|FOF_NO_CONNECTED_ELEMENTS;
	fileOp.pFrom=&srcBuf[0];
	fileOp.pTo=&destBuf[0];

	//ړs
	if(::SHFileOperation(&fileOp)){
		//G[
		strLog=CString(MAKEINTRESOURCE(IDS_ERROR_FILE_MOVE));
		return false;
	}else if(fileOp.fAnyOperationsAborted){
		//LZ
		strLog=CString(MAKEINTRESOURCE(IDS_ERROR_USERCANCEL));
		return false;
	}

	return true;
}
