#pragma once
#include "../resource.h"
#include "FileTreeView.h"
//#include "FileListView.h"
#include "../archivermanager.h"
#include "ShellDataManager.h"
#include "../ConfigCode/config.h"
#include "OLE/DnD.h"
#include "../Components/TemporaryDirMgr.h"
#include "MenuCommand.h"
//#include "FileListView.h"
#include "OLE/DropTarget.h"	//hbv󂯓,IDropCommunicator


const LPCTSTR LHAFORGE_FILE_LIST_CLASS=_T("LhaForgeFileList");

class CFileListFrame:public CFrameWindowImpl<CFileListFrame>,public CUpdateUI<CFileListFrame>,public CMessageFilter,public CIdleHandler,public CCustomDraw<CFileListFrame>,public IDropCommunicator/*ÕC^[tFCX*/
{
protected:
	bool m_bFirst;		//\
	DLL_ID m_idForceDLL;	//gpDLL
	bool m_bExtractEach;	//It@Ĉ݂𓀂łȂtrue
	//--------------
	// t@C
	//--------------
	CDirectoryTree		m_RootNode;
	CDirectoryTree		*m_lpCurrentNode;
	CArchiverDLL		*m_lpArchiver;
	CConfigManager		&Config;
	CString				m_strArcFileName;
	void RefreshFileList();
	bool MakeFileList();
	bool UpDir();
	bool DownDir(CDirectoryTree*);
	void Clear();
	bool OpenAssociation(bool bOverwrite,bool bOpen);
	bool AddFileToArchive(std::list<CString>&,LPCTSTR lpDestDir);	//t@Cǉk
	CTemporaryDirectoryManager m_TempDirManager;	//e|fBNg}l[W

	std::vector<CMenuCommandItem> m_MenuCommandArray;	//uvOŊJṽR}h

	//----------------------
	// EBhE֌Wo
	//----------------------
	CAccelerator			m_AccelEx;		//ǉ̃EBhEANZ[^:[ESC]ŃEBhEAS
	const CString			m_strPropString;	// SetProp̎ʖ
	CSplitterWindow			m_SplitterWindow;	// Xvb^EBhE
	//CFileListView			m_FileListView;	// t@Cꗗ
	CListViewCtrl			m_FileListView;	// t@Cꗗ
	CFileTreeView			m_FileTreeView;	// tH_̃c[r[
	CMultiPaneStatusBarCtrl m_StatusBar;	//Xe[^Xo[
	CRect					m_WindowRect;		// EBhETCY
	int						m_ColumnIndexArray[FILEINFO_MAX_NUM];	//JCfbNXƃTuACeԍ̑Ή
		//Config.FileListWindow.ColumnOrderArray?ɂ́AJяFILEINFO_TYPE̒lœĂ(\ڂ-1)B
		//m_ColumnIndexArrayɂ́Aǂ̃JCfbNXFILEINFO_TYPE\Ă邩Ai[Ă
		//m_ColumnIndexArray[яςĂȂԂō琔CfbNX]=FILEINFO_TYPE
	COLEDnDSource DnD;	//DnDnh
	CDropTarget m_DropTarget;	//hbv󂯓Ɏg
	int m_nDropHilight;		//hbvnCCgԂɂACẽCfbNX

	LRESULT OnCreate(LPCREATESTRUCT lpcs);
	LRESULT OnDestroy(UINT, WPARAM, LPARAM, BOOL& bHandled);
	void OnSize(UINT uType, CSize);
	void OnMove(const CPoint&);
	void OnCommandCloseWindow(UINT uNotifyCode, int nID, HWND hWndCtl);
	void OnUpDir(UINT,int,HWND);
	void OnToggleFocus(UINT,int,HWND);
	void OnConfigure(UINT,int,HWND);
	LRESULT OnClick(LPNMHDR pnmh);
	LRESULT OnTreeSelect(LPNMHDR pnmh);
	void EnableAll(bool bEnable);
	bool SetListViewColumn();	//Xgr[̃JZbg
	void OnOpenAssociation(UINT,int,HWND);	//ꎞtH_ɓWJt@C֘AtŊJ
	void OnExtractTemporary(UINT,int,HWND);	//ꎞtH_ɓWJ
	void OnClearTemporary(UINT,int,HWND);	//ꎞtH_ɂ
	void EnableAddFile(bool);	//t@C̃hbv󂯓邩ǂ̐ݒ
//	void OnAddFile(UINT,int,HWND);

	//--------------
	// Xgr[
	//--------------
	LRESULT OnDblClick(LPNMHDR pnmh);
	LRESULT OnGetDispInfo(LPNMHDR pnmh);
	LRESULT OnGetInfoTip(LPNMHDR pnmh);
	bool SetFileList();
	CShellDataManager m_ShellDataManager;
	void OnListViewStyle(UINT,int,HWND);
	void OnRefresh(UINT,int,HWND);
	void OnExtract(UINT,int,HWND);	//It@C
	void OnDelete(UINT,int,HWND);
	void OnSelectAll(UINT,int,HWND);
	void OnExtractArchive(UINT,int,HWND);	//A[JCuׂĉ
	void OnShowCustomizeColumn(UINT,int,HWND);	//Jwb_ҏWj[\
	void OnListMode(UINT,int,HWND);	//\[hύX
	void OnFindItem(UINT,int,HWND);	//t@C
	LRESULT OnFocus(LPNMHDR pnmh);
	LRESULT OnFindItem(LPNMHDR pnmh);
	LRESULT OnSortItem(LPNMHDR pnmh);
	LRESULT OnItemChanged(LPNMHDR pnmh);
	LRESULT OnBeginDrag(LPNMHDR pnmh);
	LRESULT OnColumnClick(int, LPNMHDR pnmh, BOOL& bHandled);//Jwb_ENbN
	void OnContextMenu(HWND,CPoint&);
	LRESULT OnUserApp(WORD,WORD,HWND,BOOL&);	//uvOŊJṽnh
	void OnOpenArchive(UINT,int,HWND);

	//\[g֌W
	bool bSortDescending;
	int m_nSortColumn;
	CDirectoryTree* GetFileListItemByIndex(long iIndex);

	//t@C擾
	static void GetInfoTip_FileSize(CString&,LARGE_INTEGER,BOOL bInByte);
	static void GetInfoTip_FileTime(CString&,LPFILETIME);

	// bZ[W}bv
	BEGIN_MSG_MAP_EX(CFileListFrame)
		NOTIFY_CODE_HANDLER_EX(LVN_GETDISPINFO, OnGetDispInfo)
		MSG_WM_CREATE(OnCreate)
		MESSAGE_HANDLER(WM_DESTROY,OnDestroy)
		MSG_WM_SIZE(OnSize)
		MSG_WM_MOVE(OnMove)
		MSG_WM_CONTEXTMENU(OnContextMenu)	//ENbNj[
		COMMAND_ID_HANDLER_EX(ID_MENUITEM_CLOSE_WINDOW,OnCommandCloseWindow)
		COMMAND_ID_HANDLER_EX(ID_MENUITEM_UPDIR,OnUpDir)
		COMMAND_ID_HANDLER_EX(ID_MENUITEM_LISTVIEW_SMALLICON,OnListViewStyle)
		COMMAND_ID_HANDLER_EX(ID_MENUITEM_LISTVIEW_LARGEICON,OnListViewStyle)
		COMMAND_ID_HANDLER_EX(ID_MENUITEM_LISTVIEW_REPORT,OnListViewStyle)
		COMMAND_ID_HANDLER_EX(ID_MENUITEM_LISTVIEW_LIST,OnListViewStyle)
		COMMAND_ID_HANDLER_EX(ID_MENUITEM_TOGGLE_FOCUS,OnToggleFocus)
		COMMAND_ID_HANDLER_EX(ID_MENUITEM_REFRESH,OnRefresh)
		COMMAND_ID_HANDLER_EX(ID_MENUITEM_EXTRACT_SELECTED,OnExtract)
		COMMAND_ID_HANDLER_EX(ID_MENUITEM_EXTRACT_SELECTED_SAMEDIR,OnExtract)
		COMMAND_ID_HANDLER_EX(ID_MENUITEM_DELETE_SELECTED,OnDelete)
		COMMAND_ID_HANDLER_EX(ID_MENUITEM_EXTRACT_ARCHIVE,OnExtractArchive)
		COMMAND_ID_HANDLER_EX(ID_MENUITEM_SELECT_ALL,OnSelectAll)
		COMMAND_ID_HANDLER_EX(ID_MENUITEM_CONFIGURE,OnConfigure)
		COMMAND_ID_HANDLER_EX(ID_MENUITEM_OPEN_ASSOCIATION,OnOpenAssociation)
		COMMAND_ID_HANDLER_EX(ID_MENUITEM_OPEN_ASSOCIATION_OVERWRITE,OnOpenAssociation)
		COMMAND_ID_HANDLER_EX(ID_MENUITEM_EXTRACT_TEMPORARY,OnExtractTemporary)
		COMMAND_ID_HANDLER_EX(ID_MENUITEM_CLEAR_TEMPORARY,OnClearTemporary)
		COMMAND_ID_HANDLER_EX(ID_MENUITEM_SHOW_COLUMNHEADER_MENU,OnShowCustomizeColumn)
		COMMAND_ID_HANDLER_EX(ID_MENUITEM_LISTMODE_TREE,OnListMode)
		COMMAND_ID_HANDLER_EX(ID_MENUITEM_LISTMODE_FLAT,OnListMode)
		COMMAND_ID_HANDLER_EX(ID_MENUITEM_LISTMODE_FLAT_FILESONLY,OnListMode)
		COMMAND_RANGE_HANDLER(ID_MENUITEM_USERAPP_BEGIN,ID_MENUITEM_USERAPP_END,OnUserApp)
		COMMAND_ID_HANDLER_EX(ID_MENUITEM_FINDITEM,OnFindItem)
		COMMAND_ID_HANDLER_EX(ID_MENUITEM_FINDITEM_END,OnFindItem)
		COMMAND_ID_HANDLER_EX(ID_MENUITEM_OPENARCHIVE,OnOpenArchive);
//		COMMAND_ID_HANDLER_EX(ID_MENUITEM_ADDFILE,OnAddFile)
//		COMMAND_ID_HANDLER_EX(ID_MENUITEM_ADDFILE_POPUP,OnAddFile)
		NOTIFY_CODE_HANDLER_EX(NM_DBLCLK, OnDblClick)
		NOTIFY_CODE_HANDLER_EX(NM_RETURN, OnDblClick)
		NOTIFY_CODE_HANDLER_EX(NM_CLICK, OnClick)
		NOTIFY_CODE_HANDLER_EX(TVN_SELCHANGED, OnTreeSelect)
		NOTIFY_CODE_HANDLER_EX(NM_SETFOCUS, OnFocus)
		NOTIFY_CODE_HANDLER_EX(NM_KILLFOCUS, OnFocus)
		NOTIFY_CODE_HANDLER_EX(LVN_GETINFOTIP, OnGetInfoTip)
		NOTIFY_CODE_HANDLER_EX(LVN_ODFINDITEM, OnFindItem)
		NOTIFY_CODE_HANDLER_EX(LVN_COLUMNCLICK, OnSortItem)
		NOTIFY_CODE_HANDLER_EX(LVN_ITEMCHANGED, OnItemChanged)
		NOTIFY_CODE_HANDLER_EX(LVN_BEGINDRAG, OnBeginDrag)
		NOTIFY_CODE_HANDLER(NM_RCLICK, OnColumnClick)	//Jwb_ENbN
//		CHAIN_CLIENT_COMMANDS()
		CHAIN_MSG_MAP(CUpdateUI<CFileListFrame>)
		CHAIN_MSG_MAP(CFrameWindowImpl<CFileListFrame>)
		CHAIN_MSG_MAP(CCustomDraw<CFileListFrame>)		// CCustomDrawNXփ`F[
//		REFLECT_NOTIFICATIONS()
	END_MSG_MAP()

public:
	DECLARE_FRAME_WND_CLASS_EX(LHAFORGE_FILE_LIST_CLASS,IDR_MAINFRAME,CS_HREDRAW | CS_VREDRAW | CS_DBLCLKS, COLOR_WINDOW)

	BEGIN_UPDATE_UI_MAP(CFileListFrame)
		UPDATE_ELEMENT(ID_MENUITEM_LISTVIEW_SMALLICON,			UPDUI_MENUPOPUP|UPDUI_TOOLBAR)
		UPDATE_ELEMENT(ID_MENUITEM_LISTVIEW_LARGEICON,			UPDUI_MENUPOPUP|UPDUI_TOOLBAR)
		UPDATE_ELEMENT(ID_MENUITEM_LISTVIEW_REPORT,				UPDUI_MENUPOPUP|UPDUI_TOOLBAR)
		UPDATE_ELEMENT(ID_MENUITEM_LISTVIEW_LIST,				UPDUI_MENUPOPUP|UPDUI_TOOLBAR)
		UPDATE_ELEMENT(ID_MENUITEM_EXTRACT_ARCHIVE,				UPDUI_MENUPOPUP|UPDUI_TOOLBAR)
		UPDATE_ELEMENT(ID_MENUITEM_CLEAR_TEMPORARY,				UPDUI_MENUPOPUP|UPDUI_TOOLBAR)
		UPDATE_ELEMENT(ID_MENUITEM_EXTRACT_SELECTED,			UPDUI_MENUPOPUP|UPDUI_TOOLBAR)
		UPDATE_ELEMENT(ID_MENUITEM_DELETE_SELECTED,				UPDUI_MENUPOPUP|UPDUI_TOOLBAR)
		UPDATE_ELEMENT(ID_MENUITEM_UPDIR,						UPDUI_MENUPOPUP|UPDUI_TOOLBAR)
		UPDATE_ELEMENT(ID_MENUITEM_SELECT_ALL,					UPDUI_MENUPOPUP/*|UPDUI_TOOLBAR*/)
		UPDATE_ELEMENT(ID_MENUITEM_OPEN_ASSOCIATION,			UPDUI_MENUPOPUP|UPDUI_TOOLBAR)
		UPDATE_ELEMENT(ID_MENUITEM_OPEN_ASSOCIATION_OVERWRITE,	UPDUI_MENUPOPUP|UPDUI_TOOLBAR)
		UPDATE_ELEMENT(ID_MENUITEM_EXTRACT_TEMPORARY,			UPDUI_MENUPOPUP|UPDUI_TOOLBAR)
		UPDATE_ELEMENT(ID_MENUITEM_EXTRACT_SELECTED_SAMEDIR,	UPDUI_MENUPOPUP|UPDUI_TOOLBAR)
		UPDATE_ELEMENT(ID_MENUITEM_SHOW_COLUMNHEADER_MENU,		UPDUI_MENUPOPUP|UPDUI_TOOLBAR)
		UPDATE_ELEMENT(ID_MENUITEM_LISTMODE_TREE,				UPDUI_MENUPOPUP|UPDUI_TOOLBAR)
		UPDATE_ELEMENT(ID_MENUITEM_LISTMODE_FLAT,				UPDUI_MENUPOPUP|UPDUI_TOOLBAR)
		UPDATE_ELEMENT(ID_MENUITEM_LISTMODE_FLAT_FILESONLY,		UPDUI_MENUPOPUP|UPDUI_TOOLBAR)
		UPDATE_ELEMENT(ID_MENUITEM_FINDITEM,					UPDUI_MENUPOPUP|UPDUI_TOOLBAR)
		UPDATE_ELEMENT(ID_MENUITEM_FINDITEM_END,				UPDUI_MENUPOPUP|UPDUI_TOOLBAR)
//		UPDATE_ELEMENT(ID_MENUITEM_ADDFILE,						UPDUI_MENUPOPUP|UPDUI_TOOLBAR)
//		UPDATE_ELEMENT(ID_MENUITEM_ADDFILE_POPUP,				UPDUI_MENUPOPUP|UPDUI_TOOLBAR)
	END_UPDATE_UI_MAP()

	//---
	CFileListFrame(CConfigManager &conf,LPCTSTR ps,DLL_ID);

	BOOL OnIdle(){
		UIUpdateStatusBar();
        UIUpdateToolBar();
		return FALSE;
	}
	BOOL PreTranslateMessage(MSG* pMsg);

	bool SetArchiveFile(LPCTSTR fname);

	//JX^h[
	DWORD OnPrePaint(int nID, LPNMCUSTOMDRAW lpnmcd);
	DWORD OnItemPrePaint(int nID, LPNMCUSTOMDRAW lpnmcd);

	//----------------------
	//IDropCommunicator̎
	HRESULT DragEnter(IDataObject*,POINTL&,DWORD&);
	HRESULT DragLeave();
	HRESULT DragOver(IDataObject*,POINTL&,DWORD&);
	HRESULT Drop(IDataObject*,POINTL&,DWORD&);
};
