#include "common.h"
#include "FileTreeView.h"
#include "../util.h"
//#include "../const.h"

LRESULT CFileTreeView::OnCreate(LPCREATESTRUCT lpcs)
{
	LRESULT lRes=DefWindowProc();
	SetFont(AtlGetDefaultGuiFont());

	//C[WXg쐬
	ImageList.Create(::GetSystemMetrics(SM_CXSMICON), ::GetSystemMetrics(SM_CXSMICON), ILC_COLOR32 | ILC_MASK, 8, 1);
	SetImageList(ImageList,TVSIL_NORMAL);
	//tH_ACR擾
	SHFILEINFO shfi;
	SHGetFileInfo(_T(""),FILE_ATTRIBUTE_DIRECTORY,&shfi,sizeof(shfi),SHGFI_USEFILEATTRIBUTES|SHGFI_ICON|SHGFI_SMALLICON);
	ImageList.AddIcon(shfi.hIcon);
	SHGetFileInfo(_T(""),FILE_ATTRIBUTE_DIRECTORY,&shfi,sizeof(shfi),SHGFI_USEFILEATTRIBUTES|SHGFI_ICON|SHGFI_SMALLICON|SHGFI_OPENICON);
	ImageList.AddIcon(shfi.hIcon);

	return lRes;
}

LRESULT CFileTreeView::OnDestroy()
{
	ImageList.Destroy();
	return 0;
}


bool CFileTreeView::MakeTree(CDirectoryTree *Node,HTREEITEM hParentItem,bool bExpandTree,FILELISTMODE FileListMode)
{
	HTREEITEM hItem;
	if(NULL==hParentItem){
		ASSERT(NULL==Node->GetParent());
//		if(Node->GetParent())return false;	//eACeNULLȂ̂̓m[h_̎Ɍ
		{
			TCHAR Temp[_MAX_PATH+1];
			FILL_ZERO(Temp);
			_tcsncpy_s(Temp,Node->GetFullPath(),_MAX_PATH);
			PathStripPath(Temp);
			hItem=InsertItem(Temp, TVI_ROOT, TVI_LAST);
		}
		SetItemImage(hItem,2,2);

		//A[JCuACR̐ݒ
		ImageList.Remove(2);	//ÂACR폜

		//֘At̃AACR擾
		SHFILEINFO shfi;
		::SHGetFileInfo(Node->GetFullPath(), 0, &shfi, sizeof(shfi),SHGFI_ICON | SHGFI_SMALLICON);
		ImageList.AddIcon(shfi.hIcon);
	}
	else{
		//*Nodeǉ
		hItem=InsertItem(Node->GetName(),hParentItem,TVI_LAST);
		SetItemImage(hItem,0,1);
	}
	ItemMap.insert(std::pair<CDirectoryTree*,HTREEITEM>(Node,hItem));
	//ACẽf[^Ƀm[h̃|C^ݒ
	SetItemData(hItem,(DWORD_PTR)Node);

	if(FileListMode!=FILELIST_TREE){
		//Kw\𖳎ꍇɂ́Az̃m[hɂ͏s킹A
		return true;
	}

	//*Nodez̃tH_ɑ΂ď
	std::vector<CDirectoryTree*>::iterator ite=Node->GetIterator(true);
	const std::vector<CDirectoryTree*>::iterator end=Node->GetIterator(false);
	for(;ite!=end;ite++){
		if((*ite)->IsDirectory()){
			//fBNgȂǉ
			MakeTree((*ite),hItem,bExpandTree,FileListMode);
		}
	}
	if(bExpandTree){
		Expand(hItem);
	}
	return true;
}

bool CFileTreeView::SetCurrentNode(CDirectoryTree *Node)
{
	std::map<CDirectoryTree*,HTREEITEM>::iterator ite=ItemMap.find(Node);
	if(ItemMap.end()==ite){
		return false;
	}
	EnsureVisible((*ite).second);
//	if(!SetItemState((*ite).second,TVIS_SELECTED,TVIS_SELECTED))return false;
	SelectItem((*ite).second);
	return true;
}

void CFileTreeView::Clear()
{
	DeleteAllItems();
	ItemMap.clear();
}
