#include "common.h"
#include "DropSource.h"
#include "../extractex.h"
#include "../../util.h"
//Original code from http://hp.vector.co.jp/authors/VA016117/
//Modified by Claybird http://claybird.hp.infoseek.co.jp/

HRESULT __stdcall CDropSource::QueryInterface(const IID& iid, void** ppv)
{
	HRESULT hr;

	if(iid == IID_IDropSource || iid == IID_IUnknown){
		hr = S_OK;
		*ppv = (void*)this;
		AddRef();
	}else{
		hr = E_NOINTERFACE;
		*ppv = 0;
	}
	return hr;
}


ULONG __stdcall CDropSource::AddRef()
{
	InterlockedIncrement(&_RefCount);
	return (ULONG)_RefCount;
}


ULONG __stdcall CDropSource::Release()
{
	ULONG ret = (ULONG)InterlockedDecrement(&_RefCount);
	if(ret == 0){
		delete this;
	}
	return (ULONG)_RefCount;
}

HRESULT __stdcall CDropSource::QueryContinueDrag(BOOL fEscapePressed, DWORD grfKeyState)
{
	ATLASSERT(lpRoot);
	if(!lpRoot){
		return DRAGDROP_S_CANCEL;
	}
	// hbOp邩ǂ߂

	// ESCꂽꍇ}EX̃{^ꂽƂ͒~
	if(fEscapePressed || (MK_LBUTTON | MK_RBUTTON) == (grfKeyState & (MK_LBUTTON | MK_RBUTTON))){
		return DRAGDROP_S_CANCEL;
	}

	// }EX{^ꂽƂ̓hbv
	if((grfKeyState & (MK_LBUTTON | MK_RBUTTON)) == 0){
		//𓀊Jn;sŒ~
		if(DROPEFFECT_NONE!=m_dwEffect){
			m_bRet=ExtractEx(Archiver,ArcFileName,Base,ItemList,OutputDir,lpRoot->IsFindMode(),m_strLog);
			TRACE(_T("m_bRet=%d\n"),m_bRet);
			//TRACE(_T("strLog=%s\n"),m_strLog);
			if(!m_bRet){
				return DRAGDROP_S_CANCEL;
			}
		}
		return DRAGDROP_S_DROP;
	}
	return S_OK;
}

HRESULT __stdcall CDropSource::GiveFeedback(DWORD dwEffect)
{
	m_dwEffect=dwEffect;
	/* }EXJ[\ςAʂȕ\Ƃ͂ōs */

	//W̃}EXJ[\g
	return DRAGDROP_S_USEDEFAULTCURSORS;
}
