#include "common.h"
#include "DropTarget.h"
#include "../../Util.h"

HRESULT __stdcall CDropTarget::QueryInterface(const IID& iid, void** ppv)
{
	HRESULT hr;

	if(iid == IID_IDropTarget || iid == IID_IUnknown){
		hr = S_OK;
		*ppv = (void*)this;
		AddRef();
	}else{
		hr = E_NOINTERFACE;
		*ppv = 0;
	}
	return hr;
}


ULONG __stdcall CDropTarget::AddRef()
{
	InterlockedIncrement(&_RefCount);
	return (ULONG)_RefCount;
}


ULONG __stdcall CDropTarget::Release()
{
	ULONG ret = (ULONG)InterlockedDecrement(&_RefCount);
/*	if(ret == 0){
		delete this;
	}*/	//newĂȂ̂deleteȂ
	return (ULONG)_RefCount;
}

HRESULT __stdcall CDropTarget::DragEnter(IDataObject* pDataObject, DWORD grfKeyState, POINTL ptl, DWORD* pdwEffect)
{
	m_bDrag=true;
	m_lpDataObject=pDataObject;
	return m_lpCommunicator->DragEnter(m_lpDataObject,ptl,*pdwEffect);
}


HRESULT __stdcall CDropTarget::DragOver(DWORD grfKeyState, POINTL ptl, DWORD* pdwEffect)
{
	return m_lpCommunicator->DragOver(m_lpDataObject,ptl,*pdwEffect);
}


HRESULT __stdcall CDropTarget::DragLeave()
{
	m_bDrag=false;
	m_lpDataObject=NULL;
	return m_lpCommunicator->DragLeave();
}

HRESULT __stdcall CDropTarget::Drop(IDataObject* pDataObject, DWORD grfKeyState, POINTL ptl, DWORD* pdwEffect)
{
	m_bDrag=false;
	m_lpDataObject=NULL;
	return m_lpCommunicator->Drop(pDataObject,ptl,*pdwEffect);
}

//------------
//tH[}bg𒲂ׂ
bool CDropTarget::QueryFormat(CLIPFORMAT cfFormat)
{
	ASSERT(m_lpDataObject);
	if(!m_lpDataObject)return false;
	FORMATETC fmt;

	fmt.cfFormat = cfFormat;
	fmt.ptd = NULL;
	fmt.dwAspect = DVASPECT_CONTENT;
	fmt.lindex = -1;
	fmt.tymed = TYMED_HGLOBAL;
	return S_OK==m_lpDataObject->QueryGetData(&fmt);
}

